<?php

/**
 * Compile content of post
 *
 * @package CompileContentOfPost
 * @version 2.2
 * @author davidhs
 * @copyright 2013-2018 by davidhs
 * @license Creative Commons Attribution 3.0 Unported License https://creativecommons.org/licenses/by/3.0/
 */

if (file_exists(dirname(__FILE__) . '/SSI.php') && !defined('SMF'))
	require_once (dirname(__FILE__) . '/SSI.php');
elseif (!defined('SMF'))
	exit('<b>Error:</b> Cannot install - please verify you put this in the same place as SMF\'s index.php.');

// Installs.
if (empty($context['uninstalling']))
{
	// Upgrades from 1.0 to 2.0.
	if (!isset($modSettings['ccop_ids']))
	{
		$ids = array();
		$no_ids = array();
		for ($id = 1; $id <= 5; $id++)
		{
			if (!empty($modSettings['ccop_' . $id]))
				$ids[] = $id;
			else
				$no_ids[] = $id;
		}

		$setArray = array();
		$setArray['ccop_ids'] = implode(',', $ids);
		foreach ($ids as $id)
		{
			$setArray['ccop_' . $id . '_description'] = isset($modSettings['ccop_' . $id . '_description']) ? $func['htmlspecialchars']($modSettings['ccop_' . $id . '_description'], ENT_QUOTES) : '';
			$setArray['ccop_' . $id . '_content'] = isset($modSettings['ccop_' . $id . '_bbc']) ? $modSettings['ccop_' . $id . '_bbc'] : '';
			$setArray['ccop_' . $id . '_type'] = !empty($modSettings['ccop_' . $id . '_type']) ? $modSettings['ccop_' . $id . '_type'] : 'all';

			if (empty($modSettings['ccop_' . $id . '_boards']))
				$setArray['ccop_' . $id . '_boards'] = 'all';
			else
			{
				$boards = explode(',', $modSettings['ccop_' . $id . '_boards']);
				$setArray['ccop_' . $id . '_boards'] = in_array('all', $boards) ? 'all' : $modSettings['ccop_' . $id . '_boards'];
			}

			if (empty($modSettings['ccop_' . $id . '_child_boards']))
				$setArray['ccop_' . $id . '_child_boards'] = 0;
			elseif ('all' == $modSettings['ccop_' . $id . '_child_boards'] || 255 < (int) $modSettings['ccop_' . $id . '_child_boards'])
				$setArray['ccop_' . $id . '_child_boards'] = '';
			else
				$setArray['ccop_' . $id . '_child_boards'] = $modSettings['ccop_' . $id . '_child_boards'];

			$setArray['ccop_' . $id . '_show'] = !empty($modSettings['ccop_' . $id . '_show']) ? $modSettings['ccop_' . $id . '_show'] : 'content';
			$setArray['ccop_' . $id . '_position'] = !empty($modSettings['ccop_' . $id . '_position']) ? $modSettings['ccop_' . $id . '_position'] : 'updown';
		}

		$replaceArray = array();
		foreach ($setArray as $variable => $value)
			$replaceArray[] = "(SUBSTRING('$variable', 1, 255), SUBSTRING('" . addslashes($value) . "', 1, 65534))";

		db_query("
			REPLACE INTO {$db_prefix}settings
				(variable, value)
			VALUES " . implode(',
				', $replaceArray), __FILE__, __LINE__);

		foreach ($no_ids as $no_id)
		{
			db_query("
				DELETE FROM {$db_prefix}settings
				WHERE variable LIKE 'ccop\\_$no_id\\_%'", __FILE__, __LINE__);
		}

		for ($id = 1; $id <= 5; $id++)
		{
			db_query("
				DELETE FROM {$db_prefix}settings
				WHERE variable = 'ccop_$id'", __FILE__, __LINE__);
		}

		db_query("
			DELETE FROM {$db_prefix}settings
			WHERE variable LIKE 'ccop\\_%\\_bbc'", __FILE__, __LINE__);

		// Kill the cache - it needs redoing now, but we won't bother ourselves with that here.
		cache_put_data('modSettings', null, 90);
	}

	// Upgrades from 2.0-2.1.x to 2.2.
	if (!empty($modSettings['ccop_ids']))
	{
		$ids = explode(',', $modSettings['ccop_ids']);
		if (!isset($modSettings['ccop_' . $ids[0] . '_active']))
		{
			$setArray = array();
			foreach ($ids as $id)
				$setArray['ccop_' . $id . '_active'] = '1';

			$replaceArray = array();
			foreach ($setArray as $variable => $value)
				$replaceArray[] = "(SUBSTRING('$variable', 1, 255), SUBSTRING('" . addslashes($value) . "', 1, 65534))";

			db_query("
				REPLACE INTO {$db_prefix}settings
					(variable, value)
				VALUES " . implode(',
					', $replaceArray), __FILE__, __LINE__);

			// Kill the cache - it needs redoing now, but we won't bother ourselves with that here.
			cache_put_data('modSettings', null, 90);
		}
	}
}

?>